
#include "consts.h"
#include "cool.h"


typedef struct {
    double r, rho, u, P;
} t_solvec;

typedef struct {
    double gamma, mu_a, mu_i, metal;
} t_eos;

typedef struct {
    double dE, dM, Rsc, vinf, eta, Msc, MBH, dMld;
} t_clpar;

typedef struct {
    double rk4tol, Rmax, Nrmin, Nrmax, NT;
} t_numpar;


double B(double gamma);

double get_qe(double dE, double Rsc, double eta);

double get_qm(double dM, double Rsc);

double rho_c_adia(double dM, double Rsc, double vinf, double gamma);

double P_c_adia(double dM, double Rsc, double vinf, double gamma);

double T_c_adia(double qe, double qm, t_eos eos);

double cs2(double T, t_eos eos);

double dM2vinf(double dE, double dM, double eta);

double vinf2dM(double dE, double vinf, double eta);

double n_st(double T_st, double qe, double qm, t_eos eos);

double P_st(double T_st, double qe, double qm, t_eos eos);

double get_T_Pmax(double qe, double qm, t_eos eos, double NT);
    
//double dudr7(double r, double u, double T, double rho, double R_st, double qe, double qm, t_eos eos);

//double dudr10(double r, double u, double T, double rho, t_eos eos);

/* integrates HD equs to compute a guess for the sonic radius */
//double Rsonic(double T_st, double R_st, double qe, double qm, t_eos eos, double Rmax, double Nr);


t_solvec *rk4_integrate(double T_st, double R_st, t_clpar clpar, t_eos eos, t_numpar numpar, double *Rson_test);

double Rsonic(double T_st, double R_st, t_clpar clpar, t_eos eos, t_numpar numpar);


//double find_T_st(double R_st, double T_Pmax, double qe, double qm, double Rsc, t_eos eos, double Rmax, double Nr, double NT);
double find_T_st(double R_st, double T_Pmax, t_clpar clpar, t_eos eos, t_numpar numpar);
            
double find_R_st(double T_Pmax, t_clpar clpar, t_eos eos, t_numpar numpar);

double find_Lcrit_new(double T_Pmax, t_clpar clpar, t_eos eos, t_numpar numpar);

    
void read_winit(t_clpar *clpar, t_eos *eos, t_numpar *numpar, char *cftype);



